<?php

$pearSniffExists = class_exists(
	'PEAR_Sniffs_Functions_FunctionDeclarationSniff', 
    true
);

if ($pearSniffExists === false) {
    $error = 'Class PHP_CodeSniffer_Standards_AbstractVariableSniff not found';
    throw new PHP_CodeSniffer_Exception($error);
}

class Maarch_Sniffs_Functions_FunctionDeclarationSignatureSniff 
    extends PEAR_Sniffs_Functions_FunctionDeclarationSniff
{


    /**
     * Returns an array of tokens this test wants to listen for.
     *
     * @return array
     */
    /*public function register()
    {
        return array(T_FUNCTION);

    }//end register()*/


    /**
     * Processes this test, when one of its tokens is encountered.
     *
     * @param PHP_CodeSniffer_File $phpcsFile The file being scanned.
     * @param int                  $stackPtr  The position of the current token 
     * 										  in the stack passed in $tokens.
     *
     * @return void
     */
    public function process(PHP_CodeSniffer_File $phpcsFile, $stackPtr)
    {
        //verif espace devant parenthese ouvrante
        $tokens = $phpcsFile->getTokens();
        $openBracket  = $tokens[$stackPtr]['parenthesis_opener'];
        if ($tokens[$openBracket - 1]['code'] === T_WHITESPACE) {
            $error = "Opening parenthesis must not be preceded by space";
            $phpcsFile->addError($error, $openBracket - 1, 
            					 "NoSpaceBeforeOpenBracket");
        }
        parent::process($phpcsFile, $stackPtr);
    }
    
}