<?php

if (
    class_exists(
    	'PHP_CodeSniffer_Standards_AbstractVariableSniff', 
        true
    ) === false
) {
    throw new PHP_CodeSniffer_Exception(
    	'Class PHP_CodeSniffer_Standards_AbstractVariableSniff not found'
    );
}


class Maarch_Sniffs_Variables_PropertiesBeforeMethodsSniff 
    extends PHP_CodeSniffer_Standards_AbstractVariableSniff
{

    protected function processMemberVar(
        PHP_CodeSniffer_File $phpcsFile, $stackPtr
    ) {
        $tokens = $phpcsFile->getTokens();
        $propertyName = ltrim($tokens[$stackPtr]['content'], '$');
        $curScope = $phpcsFile->findPrevious(array(T_CLASS, T_INTERFACE), 
                                             $stackPtr, 0);
        $className = $phpcsFile->getDeclarationName($curScope);
        $errorData = array($className . '::' . $propertyName);
        
        if (
            ($prevMethod = $phpcsFile->findPrevious(
                array(T_FUNCTION), $stackPtr, $curScope
            )) !== false
        ) {
            $prevMethodName = $phpcsFile->getDeclarationName($prevMethod);
            $errorData[] = $className . '::' . $prevMethodName;
            $error = 'Class property %s must be declared before method %s';
            $phpcsFile->addError($error, $stackPtr, 
            					 'PropertiesBeforeMethods', $errorData); 
        }
    }
    
    protected function processVariable(
        PHP_CodeSniffer_File $phpcsFile, $stackPtr
    ) {
        return;
    }
    
    protected function processVariableInString(
        PHP_CodeSniffer_File $phpcsFile, $stackPtr
    ) {
        return;
    }
}